unit CaseSudo;

interface

uses
  SysUtils, Classes, Controls, ExtCtrls,graphics,Dialogs, Types,
   Windows, Messages, Forms,  StdCtrls;
type
  TCaseSudo = class(TImage)
  private
    { Dclarations prives }
  protected
    { Dclarations protges }
    FValue:Integer;
  public
    Possibles:Array[1..9] of Boolean;
    FOnChange:TNotifyEvent;
    { Dclarations publiques }
    Constructor Create(aOwner:TComponent);Override;
    Procedure RAZ;
  Published
    { Dclarations publies }
    Procedure SetValeur(v:Integer);
    Property Valeur:Integer Read FValue Write SetValeur Default 0;
    property OnChange:TNotifyEvent read FOnchange Write FOnchange;
    property OnClick;
    procedure SetPossibles(x:Integer;Possible:Boolean);
    Procedure AfficheValeur(Owner:Tobject);

  end;

procedure Register;

implementation

Constructor TCaseSudo.Create(aOwner:TComponent);
Begin
 Inherited Create(aOwner);
 parent:=TWinControl(aOwner);
 top:=10;
 left:=10;
 Width:=60;
 Height:=60;
 OnClick:=AfficheValeur;
 RAZ;
End;

Procedure TCaseSudo.RAZ;
Var u:Integer;
Begin
 canvas.Pen.Color:=ClBlack;
 canvas.rectangle(0,0,60,60);
 FValue:=0;
 For u:=1 to 9 Do SetPossibles(u,true);
End;

Procedure TCaseSudo.AfficheValeur;
Var mp:Tpoint;
  v:Integer;
Begin
if FValue>0 then exit;
mp:=self.ScreenToClient(Mouse.CursorPos);
//Showmessage(IntToStr(mp.x));
If mp.x<20 Then Begin If mp.y<20 Then v:=1 else if mp.y>40 Then v:=7 Else v:=4; End
else If mp.x>40 Then Begin If mp.y<20 Then v:=3 else if mp.y>40 Then v:=9 Else v:=6; End
else Begin If mp.y<20 Then v:=2 else if mp.y>40 Then v:=8 Else v:=5; End;
setvaleur(v);
End;

Procedure TCaseSudo.SetValeur(v:Integer);
Begin
If v=Valeur Then exit;
If Not Possibles[v] Then exit;
FValue:=v;
SetPossibles(v,false);
canvas.rectangle(0,0,60,60);
canvas.Font.Size:=36;
canvas.Font.Name:='Arial';
canvas.Font.Color:=clBlack;
Canvas.TextOut(15,2,IntToStr(Valeur));
OnChange(nil);
End;

Procedure TCaseSudo.SetPossibles(x:Integer;Possible:Boolean);
var px,py:Integer;
Begin
Possibles[x]:=Possible;
Case x Of
    1:Begin px:=5;py:=2;End;
    2:Begin px:=25;py:=2;End;
    3:Begin px:=45;py:=2;End;
    4:Begin px:=5;py:=22;End;
    5:Begin px:=25;py:=22;End;
    6:Begin px:=45;py:=22;End;
    7:Begin px:=5;py:=42;End;
    8:Begin px:=25;py:=42;End;
    9:Begin px:=45;py:=42;End;
End;
canvas.Font.Size:=9;
canvas.Font.Name:='Arial';
If Possible Then canvas.Font.Color:=clBlack Else canvas.Font.Color:=clWhite;
Canvas.TextOut(px,py,IntToStr(x));
End;

procedure Register;
begin
  RegisterComponents('Exemples', [TCaseSudo]);
end;

end.

