unit UResoudre;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFrmResoudre = class(TForm)
    BtnAffiche: TButton;
    BtnChercher: TButton;
    BtnFermer: TButton;
    procedure BtnAfficheClick(Sender: TObject);
    procedure BtnChercherClick(Sender: TObject);
    procedure BtnFermerClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    procedure Edit2Jeu;
    { Dclarations publiques }
  end;

var
  FrmResoudre: TFrmResoudre;
  jeur:Array[1..9,1..9] of Integer;

implementation

uses Umain;

{$R *.DFM}
Function DansCarre(c,l,x:Integer):Boolean;
Var ll,cc,li,ci:Integer;
    trouve:boolean;
Begin
   Trouve:=False;
   ll:=3*((l-1) div 3)+1;
   cc:=3*((c-1) div 3)+1;
   For li:=ll to ll+2 Do
      For ci:=cc to cc+2 Do
         If (jeur[ci,li]=x)
         Then Begin Trouve:=True;Break;End;
   Result:=trouve;
End;

Function DansLigne(c,nl,x:Integer):Boolean;
Var ll:Integer;
    trouve:boolean;
Begin
   Trouve:=False;
   For ll:=1 to 9 Do
    If (jeur[c,ll]=x)
    Then Begin Trouve:=True;Break;End;
   Result:=trouve;
End;

Function DansCol(nc,l,x:Integer):Boolean;
Var cc:Integer;
    trouve:boolean;
Begin
   Trouve:=False;
   For cc:=1 to 9 Do
    If (jeur[cc,l]=x)
    Then Begin Trouve:=True;Break;End;
   Result:=trouve;
End;

Procedure Affichejeu;
Var l,c,i,u:Integer;
    s:String;
begin
  s:='';
  for l:=1 to 9 do
  for c:=1 to 9 do
      s:=s+IntToStr(jeur[l,c]);
  u:=0;
  for I := 0 to FrmResoudre.ComponentCount-1 do
      if FrmResoudre.Components[I] is TEdit then Begin inc(u);TEdit(FrmResoudre.Components[I]).Text:=' '+s[u];End;
      Application.ProcessMessages;
End;

Var fini:Boolean;//pour s'arrter  la premiere

Procedure Cherche;//teste toutes les possibilits avec backtracking
Var n,l,c,nt:Integer;
begin
//Affichejeu;//showmessage('ok');
If fini Then Exit;
For l:=1 to 9 do
For c:=1 to 9 do
Begin
  If (jeur[c,l]<>0) Then Continue;
  For n:=1 to 9 do
     if (Not DansLigne(c,l,n))
         And (Not DansCol(c,l,n))
         And (Not DansCarre(c,l,n))
         Then Begin
             nt:=jeur[c,l];
             jeur[c,l]:=n;
             Cherche;
             jeur[c,l]:=nt;
         End;
     exit;
End;
AfficheJeu;fini:=True;//pour s'arreter a la premire
End;

procedure TFrmResoudre.BtnAfficheClick(Sender: TObject);
Var UnEdit:TEdit;
    PosX, PosY,l,c:Integer;
begin
  PosY:=80;
  For c:=1 to 9 Do Begin
  PosX:=50;
    For l:=1 to 9 Do
    Begin
      UnEdit:=TEdit.Create(Self);
        With UnEdit do
        begin
          Parent:=Self;
          Text:='0';
          Font.Size:=24;
          Font.Name:='Arial';
          Ctl3d:=False;
          width:=Height;
          Left:=PosX;
          Top:=PosY;
          PosX:=50+l*(Width+0)+10*(l div 3);
          End;
      End;
      PosY:=80+c*(UnEdit.height+0)+10*(c div 3);
  End;
  width:=PosX+50;
  Height:=PosY+50;
end;

procedure TFrmResoudre.Edit2Jeu;
var i,l,c:Integer;
    s,car:String;
begin
  for I := 0 to ComponentCount-1 do
      if Components[I] is TEdit then s:=s+copy(TEdit(Components[I]).Text,2,1);
//  ShowMessage(s);
  for l:=1 to 9 do
  for c:=1 to 9 do
  begin
      car:=copy(s,(l-1)*9+c,1);
      jeur[l,c]:=StrToInt(car);
  End;
  for l:=1 to 9 do
  Begin
  s:='';
  for c:=1 to 9 do
  begin
      s:=s+IntToStr(jeur[l,c]);
  End;
//  ShowMessage(s);
  End;
end;

procedure TFrmResoudre.BtnChercherClick(Sender: TObject);
Var Debut,Fin:DWord;
begin
  Edit2Jeu;
  fini:=false;
  Application.ProcessMessages;
  Caption:='Solveur de Sudoku par DP, recherche en cours...';
  cursor:=crHourGlass;
  Debut:=GetTickCount;
  Cherche;
  Fin:=GetTickCount;
  Caption:='Solveur de Sudoku par DP, solution trouve en '+IntToStr(Fin-debut)+' ms.';
  cursor:=crDefault;
end;

procedure TFrmResoudre.BtnFermerClick(Sender: TObject);
begin
Close;
end;

end.
