unit Umain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, CaseSudo, StdCtrls;

type
  TForm1 = class(TForm)
    BtnInit: TButton;
    Panel1: TPanel;
    BtnSolveur: TButton;
    BtnMode: TButton;
    BtnSauveGrille: TButton;
    BtnLireGrille: TButton;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    SaveDialog1: TSaveDialog;
    BtnRAZ: TButton;
    BtnQuitter: TButton;
    procedure BtnInitClick(Sender: TObject);
    procedure BtnSolveurClick(Sender: TObject);
    procedure BtnModeClick(Sender: TObject);
    procedure BtnLireGrilleClick(Sender: TObject);
    procedure BtnSauveGrilleClick(Sender: TObject);
    procedure BtnRAZClick(Sender: TObject);
    procedure BtnQuitterClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    Procedure Traite(s:TObject);
  end;

var
  Form1: TForm1;
  jeu:Array[1..9,1..9]Of TCaseSudo;
  FautConseiller:Boolean;

  implementation
Uses UResoudre;

{$R *.dfm}

procedure TForm1.Traite(s:TObject);
Var l,c,cc,ll,ccc,lll,p,u,v,ATester,ml,mc,carre:Integer;
Begin
//on commence par liminer**************************************************************************
For l:=1 to 9 Do
For c:=1 to 9 Do
begin
  If jeu[l,c].Valeur>0 Then Begin
     for cc:=1 to 9 Do If Jeu[l,cc].Valeur=0 Then jeu[l,cc].SetPossibles(jeu[l,c].Valeur,False);
     for ll:=1 to 9 Do If Jeu[ll,c].Valeur=0 Then jeu[ll,c].SetPossibles(jeu[l,c].Valeur,False);
     cc:=((c-1) div 3)*3+1;
     ll:=((l-1) div 3)*3+1;
     For lll:=ll To ll+2 Do
         For ccc:=cc To cc+2 Do If Jeu[lll,ccc].Valeur=0 Then jeu[lll,ccc].SetPossibles(jeu[l,c].Valeur,False);
   End;
End;
If Not FautConseiller Then exit;
FautConseiller:=False;
//y aurait-il des cases avec une seule possibilit?***********************************************
For l:=1 to 9 Do
For c:=1 to 9 Do
begin
   p:=0;
   For u:=1 to 9 Do If jeu[l,c].Valeur=0 Then If jeu[l,c].possibles[u] Then begin inc(p);v:=u;End;
   If p=1 Then begin
               ShowMessage('Une Possibilit ligne '+IntToStr(l)+' colonne '+IntToStr(c));
               jeu[l,c].Setvaleur(v);
               //Traite(nil);
               exit;
               End;
End;
//y aurait il des lignes avec une seule possibilit********************************
For ATester:=1 To 9 Do
For l:=1 To 9 Do Begin
    p:=0;
    For c:=1 To 9 Do
       If jeu[l,c].Valeur=0 Then If jeu[l,c].possibles[ATester] Then Begin inc(p);ml:=l;mc:=c;End;
    If p=1 Then Begin
               ShowMessage('Dans la ligne '+IntToStr(l)+' le nombre '+IntToStr(ATester)+' apparait '+IntToStr(p)+' fois');
               jeu[ml,mc].Setvaleur(ATester);
               Exit;
               End;
   End;
//y aurait il des colonnes avec une seule possibilit********************************
For ATester:=1 To 9 Do
For c:=1 To 9 Do Begin
    p:=0;
    For l:=1 To 9 Do
       If jeu[l,c].Valeur=0 Then If jeu[l,c].possibles[ATester] Then Begin inc(p);ml:=l;mc:=c;End;
    If p=1 Then Begin
               ShowMessage('Dans la colonne '+IntToStr(c)+' le nombre '+IntToStr(ATester)+' apparait '+IntToStr(p)+' fois');
               jeu[ml,mc].Setvaleur(ATester);
               Exit;
               End;
   End;
//y aurait il des carres avec une seule possibilit********************************
For Atester:=1 To 9 Do
For carre:=1 To 9 Do Begin;
  Case carre of
      1:Begin l:=1;c:=1;End;
      2:Begin l:=1;c:=4;End;
      3:Begin l:=1;c:=7;End;
      4:Begin l:=4;c:=1;End;
      5:Begin l:=4;c:=4;End;
      6:Begin l:=4;c:=7;End;
      7:Begin l:=7;c:=1;End;
      8:Begin l:=7;c:=4;End;
      9:Begin l:=7;c:=7;End;
  End;
  p:=0;
  For ll:=l To l+2 Do
     For cc:=c To c+2 Do
        If jeu[ll,cc].Valeur=0 Then If jeu[ll,cc].possibles[ATester] Then Begin inc(p);ml:=ll;mc:=cc;End;
    If p=1 Then Begin
               ShowMessage('Dans le carr '+IntToStr(carre)+' le nombre '+IntToStr(ATester)+' apparait '+IntToStr(p)+' fois');
               jeu[ml,mc].Setvaleur(ATester);
               Exit;
     End;
End;
End;

procedure TForm1.BtnInitClick(Sender: TObject);
Var l,c:Integer;
begin
For l:=1 to 9 Do
For c:=1 to 9 Do
begin
  jeu[l,c]:=TCaseSudo.Create(self);
  jeu[l,c].FOnChange:=Traite;
  jeu[l,c].Left:=10+(c-1)*(60+5)+5*((c-1) div 3);
  jeu[l,c].Top:=10+(l-1)*(60+5)+5*((l-1) div 3);
End;
Height:=panel1.Height+(l-1)*(60+5)+5*((l-1) div 3)+40;
width:=10+(l-1)*(60+5)+5*((l-1) div 3)+10;
BtnInit.visible:=False;
FautConseiller:=False;
Traite(nil);
Memo1.Visible:=False;
Caption:='MonSudoku.';
end;

procedure TForm1.BtnSolveurClick(Sender: TObject);
var s:String;
    i,l,c,u:Integer;
begin
  s:='';
  for l:=1 to 9 do
  Begin
    for c:=1 to 9 do
    begin
        s:=s+IntToStr(jeu[l,c].valeur);
    End;
  End;
  u:=0;
  for i := 0 to FrmResoudre.ComponentCount-1 do
      if FrmResoudre.Components[I] is TEdit
      then Begin inc(u);TEdit(FrmResoudre.Components[I]).Text:=' '+s[u];End;
FrmResoudre.BtnChercher.Visible:=False;
FrmResoudre.Show;
FrmResoudre.BtnChercherClick(nil);
End;

procedure TForm1.BtnModeClick(Sender:TObject);
begin
FautConseiller:=True;
Traite(nil);
end;

procedure TForm1.BtnLireGrilleClick(Sender: TObject);
Var s:String;
    c,l:Integer;
    car:Char;
begin
BtnInitClick(nil);
FautConseiller:=True;BtnModeClick(nil);
If OpenDialog1.execute
Then Begin
     Memo1.Clear;
     Memo1.Lines.loadFromFile(OpenDialog1.FileName);
//     Memo1.Visible:=true;
     For l:=0 to 8 Do Begin
     s:=Memo1.Lines[l];
//     ShowMessage(s);
     For c:=1 to 9 Do Begin
         car:=s[c];
//       ShowMessage(car);
         If (Char(Car) In ['0'..'9'])
         Then jeu[l+1,c].SetValeur(StrToInt(car))
         Else jeu[l+1,c].SetValeur(0);
     End;
     End;
 End;
Caption:='MonSudoku: '+ExtractFileName(OpenDialog1.FileName)+'.';
end;

procedure TForm1.BtnSauveGrilleClick(Sender: TObject);
Var s:String;
    c,ll:Integer;
begin
If SaveDialog1.execute
Then Begin
     Memo1.Clear;
     Memo1.Visible:=False;
     For ll:=0 to 8 Do Begin
       s:='';
       For c:=1 to 9 Do s:=s+IntToStr(jeu[ll+1,c].Valeur);
       Memo1.Lines.Add(s);
     End;
     Memo1.Lines.SaveToFile(SaveDialog1.FileName);
End;
Caption:='MonSudoku: '+ExtractFileName(SaveDialog1.FileName)+'.';
end;

procedure TForm1.BtnRAZClick(Sender: TObject);
Var l,c:Integer;
Begin
For l:=1 to 9 Do
For c:=1 to 9 Do
begin
  jeu[l,c].RAZ;
End;
Traite(nil);
Caption:='MonSudoku.';
end;

procedure TForm1.BtnQuitterClick(Sender: TObject);
begin
Close;
end;

end.
